/* GTK Napster-0.201
 * Copyright (C) 2000 Unified (xilliator@hotmail.com).
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include <string.h>
#include <stdlib.h>

#include "common.h"
#include "ndialog.h"

void ReadRCFile(gtk_sess *sess)
{
	gchar *filename[120];
	gchar buffer[120];
	FILE *rcfile;
	gchar *username;
	
	strcpy((gchar *)sess->directory, getenv("HOME"));
	sess->speed = 0;
	strcpy((gchar *)sess->email, DEFAULT_EMAIL);
	strcpy((gchar *)sess->exec_player, DEFAULT_PLAYER);
	sess->timeout = 30;
	
	sprintf((gchar *)filename, "%s/%s", getenv("HOME"), RC_FILENAME);
	
	if((rcfile = fopen((gchar *)filename, "r")) == NULL)
	{
		g_warning(WARNING_FILE_NOT_FOUND, (gchar *)filename);
		return;
	}
		
	while(fgets(buffer, 120, rcfile) != NULL)
	{
		buffer[strlen(buffer)-1] = '\0';
		
		if((strstr((gchar *)buffer, "USERNAME=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 29))
		{
			sprintf((gchar *)sess->username, "%s", &buffer[9]);
		}
		if((strstr((gchar *)buffer, "PASSWORD=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 29))
		{
			sprintf((gchar *)sess->password, "%s", &buffer[9]);
		}
		else if((strstr((gchar *)buffer, "STORE_DIR=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 110))
		{
			sprintf((gchar *)sess->directory, "%s", &buffer[10]);
		}
		else if((strstr((gchar *)buffer, "E-MAIL=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 107))
		{
			sprintf((gchar *)sess->email, "%s", &buffer[7]);
		}
		else if((strstr((gchar *)buffer, "LINE_SPEED=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 31))
		{
			sess->speed = atoi(&buffer[11]);
		}
		else if((strstr((gchar *)buffer, "TIMEOUT=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 12))
		{
			sess->timeout = atoi(&buffer[8]);
		}
		else if((strstr((gchar *)buffer, "SHOW_TABS=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 12))
		{
			sess->SHOW_TABS = (gboolean)atoi(&buffer[10]);
		}
		else if((strstr((gchar *)buffer, "SHOW_DHMS=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 12))
		{
			sess->SHOW_DHMS = (gboolean)atoi(&buffer[10]);
		}
		else if((strstr((gchar *)buffer, "SHOW_BYTE=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 12))
		{
			sess->SHOW_BYTE = (gboolean)atoi(&buffer[10]);
		}
		else if((strstr((gchar *)buffer, "REMEMBER_PASSWORD=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 20))
		{
			sess->PASSWORD = (gboolean)atoi(&buffer[18]);
		}
		else if((strstr((gchar *)buffer, "SWITCH_TO_TRANSFER=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 21))
		{
			sess->SWITCH_TRANSFER = (gboolean)atoi(&buffer[19]);
		}
		else if((strstr((gchar *)buffer, "AUTO_CONNECT=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 15))
		{
			sess->AUTO_CONNECT = (gboolean)atoi(&buffer[13]);
		}
		else if((strstr((gchar *)buffer, "PLAYER=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 157))
		{
			sprintf((gchar *)sess->exec_player, "%s", &buffer[7]);
		}
		else if((strstr((gchar *)buffer, "HOTLIST=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 28))
		{
			username = &buffer[8];
			gtk_clist_append(GTK_CLIST(sess->hotlist.offlinelist), &username);
		}
	}
	
	fclose(rcfile);
}

void get_hotlist_users(gtk_sess *sess, FILE *rcfile)
{
	GdkPixmap *pixm;
	GdkBitmap *bitm;
	gint spacing;
	gint row = 0;
	gchar *username;
	
	while(gtk_clist_get_pixtext(GTK_CLIST(sess->hotlist.onlinelist), row, 0, &username, (guint8*)&spacing, &pixm, &bitm) != 0)
	{
		fprintf(rcfile, "HOTLIST=%s\n", username);
		row++;
	}
	
	row = 0;
	
	while(gtk_clist_get_text(GTK_CLIST(sess->hotlist.offlinelist), row, 0, &username) != 0)
	{
		fprintf(rcfile, "HOTLIST=%s\n", username);
		row++;
	}
}

void WriteRCFile(gtk_sess *sess)
{
	gchar *filename[200];
	FILE *rcfile;
	
	sprintf((gchar *)filename, "%s/%s", getenv("HOME"), RC_FILENAME);
	
	if((rcfile = fopen((gchar *)filename, "w")) == NULL)
	{
		g_warning(WARNING_CANNOT_WRITE, (gchar *)filename);
		return;
	}
		
	fprintf(rcfile, "USERNAME=%s\n", (gchar *)sess->username);
	if(sess->PASSWORD) fprintf(rcfile, "PASSWORD=%s\n", (gchar *)sess->password);
	fprintf(rcfile, "LINE_SPEED=%d\n", sess->speed);
	fprintf(rcfile, "STORE_DIR=%s\n", (gchar *)sess->directory);
	fprintf(rcfile, "E-MAIL=%s\n", (gchar *)sess->email);
	fprintf(rcfile, "SHOW_TABS=%d\n", (gint)sess->SHOW_TABS);
	fprintf(rcfile, "SHOW_DHMS=%d\n", (gint)sess->SHOW_DHMS);
	fprintf(rcfile, "SHOW_BYTE=%d\n", (gint)sess->SHOW_BYTE);
	fprintf(rcfile, "REMEMBER_PASSWORD=%d\n", (gint)sess->PASSWORD);
	fprintf(rcfile, "SWITCH_TO_TRANSFER=%d\n", (gint)sess->SWITCH_TRANSFER);
	fprintf(rcfile, "AUTO_CONNECT=%d\n", (gint)sess->AUTO_CONNECT);
	fprintf(rcfile, "PLAYER=%s\n", (gchar *)sess->exec_player);
	fprintf(rcfile, "TIMEOUT=%d\n", sess->timeout);
	
	get_hotlist_users(sess, rcfile);
	
	fclose(rcfile);
}

void gtk_message_ok(gchar *message, gchar *title, gint type)
{
	GtkWidget *dialog;
	GtkWidget *label;
	GtkWidget *button;
	GtkWidget *table;
	GtkWidget *picture;
	GtkWidget *frame;
	
	dialog = gtk_dialog_new();

	gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
	gtk_window_set_modal(GTK_WINDOW(dialog), TRUE);
	gtk_window_set_title(GTK_WINDOW(dialog), title);
	
	button = gtk_button_new_with_label(BUTTON_OK);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area), button, TRUE, TRUE, 0);
	gtk_widget_show(button);
	
	if(type == 4)
	{
		frame = gtk_frame_new(NULL);
		gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), frame, TRUE, TRUE, 0);
		gtk_widget_show(frame);	
			
		picture = make_pixmapwid(dialog, banner_xpm);
		gtk_container_add(GTK_CONTAINER(frame), picture);
		gtk_widget_show(picture);
	}
	
	table = gtk_table_new(1 ,2 , FALSE);
	gtk_container_set_border_width(GTK_CONTAINER(table), 10);		
	gtk_table_set_col_spacing(GTK_TABLE(table),0, 10);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), table, TRUE, TRUE, 0);
	gtk_widget_show(table);
	
	switch(type)
	{
	case 1:
	case 2:
		label = gtk_label_new(message);
		gtk_table_attach_defaults(GTK_TABLE(table), label, 1, 2, 0, 1);
		gtk_widget_show(label);	
		
		if(type == 1)	picture = make_pixmapwid(dialog, error_xpm);
		else picture = make_pixmapwid(dialog, warning_xpm);
		gtk_table_attach_defaults(GTK_TABLE(table), picture, 0, 1, 0, 1);
		gtk_widget_show(picture);
		break;
	case 3:
		label = gtk_label_new(message);
		gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 0, 1);
		gtk_label_set_justify(GTK_LABEL(label), GTK_JUSTIFY_LEFT);
		gtk_widget_show(label);	
		break;
	case 4:
		label = gtk_label_new(message);
		gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 2, 0, 1);
		gtk_widget_show(label);
		break;			
	}
	gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(dialog));
	gtk_widget_show_all(dialog);
}

void login_connect(connect_parm *parm, gboolean newuser)
{
	strcpy((gchar *)parm->sess->username, (gchar *)gtk_entry_get_text(GTK_ENTRY(parm->user_entry)));
	strcpy((gchar *)parm->sess->password, (gchar *)gtk_entry_get_text(GTK_ENTRY(parm->pw_entry)));
		
	parm->sess->speed = get_speed_nr(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(parm->speed_combo)->entry)));
		
	strcpy((gchar *)parm->sess->directory, (gchar *)gtk_entry_get_text(GTK_ENTRY(parm->dd_entry)));
	strcpy((gchar *)parm->sess->email, (gchar *)gtk_entry_get_text(GTK_ENTRY(parm->email_entry)));
	
	if((strcmp((gchar *)parm->sess->password, "") != 0) && (strcmp((gchar *)parm->sess->username, "") != 0))
	{
		if(newuser)
		{
			if(strcmp((gchar *)parm->sess->password, gtk_entry_get_text(GTK_ENTRY(parm->pwr_entry))) == 0)
			{
				gtk_label_set_text(GTK_LABEL(parm->sess->login_label), LOGIN_LABEL_STATUS);
				gtk_notebook_set_page(GTK_NOTEBOOK(parm->notebook), 3);
				gtk_widget_set_sensitive(GTK_WIDGET(parm->back_button), FALSE);
				gtk_widget_set_sensitive(GTK_WIDGET(parm->ok_button), FALSE);
		
				while(gtk_events_pending())
					gtk_main_iteration();

				if(napster_connect(parm->sess, TRUE, &parm->LOCK, &parm->CANCEL))
				{
					gtk_widget_destroy(parm->sess->login_dialog);
				}
				else gtk_widget_set_sensitive(GTK_WIDGET(parm->back_button), TRUE);
			}
			else
			{
				gtk_message_ok(MSGBOX_PASSWORD_NOMATCH, MSGBOX_PASSWORD_NOMATCH_TITLE, DIALOG_WARNING);
			}
		}
		else
		{
			gtk_label_set_text(GTK_LABEL(parm->sess->login_label), LOGIN_LABEL_STATUS);
			gtk_notebook_set_page(GTK_NOTEBOOK(parm->notebook), 3);
			gtk_widget_set_sensitive(GTK_WIDGET(parm->back_button), FALSE);
			gtk_widget_set_sensitive(GTK_WIDGET(parm->ok_button), FALSE);
			
			while(gtk_events_pending())
				gtk_main_iteration();

			
			if(napster_connect(parm->sess, FALSE, &parm->LOCK, &parm->CANCEL))
			{
				gtk_widget_destroy(parm->sess->login_dialog);
			}
			else gtk_widget_set_sensitive(GTK_WIDGET(parm->back_button), TRUE);
		}
	}
	else gtk_message_ok(MSGBOX_MUST_ENTER, MSGBOX_MUST_ENTER_TITLE, DIALOG_WARNING);
}

void ok_button_func(GtkWidget *widget, gpointer data)
{
	gboolean newuser;

	connect_parm *parm = (connect_parm *)data;
	
	newuser = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(parm->new_user));
	parm->sess->PASSWORD = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(parm->retry_check));
	
	switch (gtk_notebook_get_current_page(GTK_NOTEBOOK(parm->notebook)))
	{
	case 0:
		if(newuser)
		{
			gtk_notebook_set_page(GTK_NOTEBOOK(parm->notebook), 1);
			gtk_widget_set_sensitive(GTK_WIDGET(parm->back_button), TRUE);
		}
		else
		{
			login_connect(parm, newuser);
		}
		break;
	case 1:
		gtk_notebook_set_page(GTK_NOTEBOOK(parm->notebook), 2);
		break;
	case 2:
		login_connect(parm, newuser);
		break;
	}
}

void cancel_button_func(GtkWidget *widget, gpointer data)
{
	connect_parm *parm = (connect_parm *)data;

	if((parm->LOCK) && (gtk_notebook_get_current_page(GTK_NOTEBOOK(parm->notebook)) == 3))
	{
		parm->CANCEL = TRUE;
		gtk_widget_set_sensitive(GTK_WIDGET(parm->back_button), TRUE);
		return;
	}
	
	gtk_widget_destroy(parm->sess->login_dialog);
}

void back_button_func(GtkWidget *widget, gpointer data)
{
	gboolean newuser;
	connect_parm *parm = (connect_parm *)data;
	
	newuser = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(parm->new_user));
	
	switch (gtk_notebook_get_current_page(GTK_NOTEBOOK(parm->notebook)))
	{
	case 3:
		if(!parm->sess->CONNECTED)
		{
			if(newuser)
			{
				gtk_notebook_set_page(GTK_NOTEBOOK(parm->notebook), 2);
				gtk_widget_set_sensitive(GTK_WIDGET(parm->ok_button), TRUE);
			}
			else
			{
				gtk_notebook_set_page(GTK_NOTEBOOK(parm->notebook), 0);
				gtk_widget_set_sensitive(GTK_WIDGET(parm->ok_button), TRUE);
				gtk_widget_set_sensitive(GTK_WIDGET(parm->back_button), FALSE);
			}
		}
		break;
	case 2:
		gtk_notebook_set_page(GTK_NOTEBOOK(parm->notebook), 1);
		break;
	case 1:
		gtk_notebook_set_page(GTK_NOTEBOOK(parm->notebook), 0);
		gtk_widget_set_sensitive(GTK_WIDGET(parm->back_button), FALSE);
		break;
	}
}

void dialog_destroy(GtkWidget *widget, gpointer data)
{
	connect_parm *parm = (connect_parm *)data;
	if(parm->LOCK) parm->CANCEL = TRUE; 
	g_free(parm);
}

void connect_dialog(GtkWidget *widget, gpointer data)
{
	GtkWidget *user_label;
	GtkWidget *pw_label;
	GtkWidget *speed_label;
	GtkWidget *dd_label;
	GtkWidget *table;
	GtkWidget *new_table;
	GtkWidget *misc_table;
	GtkWidget *pm_banner;
	GtkWidget *frame;
	GtkWidget *email_label;
	GtkWidget *pwr_label;
	GtkWidget *alignment;
	connect_parm *parm;
	GList *linespeed = NULL;
		
	linespeed = g_list_append(linespeed, LINE_SPEED_UNKNOWN);
	linespeed = g_list_append(linespeed, LINE_SPEED_T3);
	linespeed = g_list_append(linespeed, LINE_SPEED_T1);
	linespeed = g_list_append(linespeed, LINE_SPEED_DSL);
	linespeed = g_list_append(linespeed, LINE_SPEED_CABLE);
	linespeed = g_list_append(linespeed, LINE_SPEED_ISDN128);
	linespeed = g_list_append(linespeed, LINE_SPEED_ISDN56);
	linespeed = g_list_append(linespeed, LINE_SPEED_56MODEM);
	linespeed = g_list_append(linespeed, LINE_SPEED_33MODEM);
	linespeed = g_list_append(linespeed, LINE_SPEED_28MODEM);
	linespeed = g_list_append(linespeed, LINE_SPEED_14MODEM);

	parm = (connect_parm *)g_malloc(sizeof(connect_parm));
	parm->sess = (gtk_sess *)data;
	parm->LOCK = FALSE;
	parm->CANCEL = FALSE;
	
	if(!parm->sess->CONNECTED)
	{
		parm->sess->login_dialog = gtk_dialog_new();

		gtk_window_set_position(GTK_WINDOW(parm->sess->login_dialog), GTK_WIN_POS_CENTER);
		gtk_window_set_modal(GTK_WINDOW(parm->sess->login_dialog), TRUE);
		gtk_window_set_title(GTK_WINDOW(parm->sess->login_dialog), LOGIN_DIALOG_TITLE);
		gtk_signal_connect(GTK_OBJECT(parm->sess->login_dialog), "destroy", GTK_SIGNAL_FUNC(dialog_destroy), parm);

		parm->back_button = gtk_button_new_with_label(BUTTON_BACK);
		gtk_box_pack_start (GTK_BOX (GTK_DIALOG (parm->sess->login_dialog)->action_area), parm->back_button, TRUE, TRUE, 0);
		gtk_widget_set_sensitive(GTK_WIDGET(parm->back_button), FALSE);
		gtk_widget_show(parm->back_button);
		
		parm->cancel_button = gtk_button_new_with_label(BUTTON_CANCEL);
		gtk_box_pack_start (GTK_BOX (GTK_DIALOG (parm->sess->login_dialog)->action_area), parm->cancel_button, TRUE, TRUE, 0);
		gtk_widget_show(parm->cancel_button);

		parm->ok_button = gtk_button_new_with_label(BUTTON_NEXT);
		gtk_box_pack_start (GTK_BOX (GTK_DIALOG (parm->sess->login_dialog)->action_area), parm->ok_button, TRUE, TRUE, 0);
		gtk_widget_show(parm->ok_button);
		
		alignment = gtk_alignment_new(0.5, 0.5 ,0 ,0);
		gtk_box_pack_start (GTK_BOX (GTK_DIALOG (parm->sess->login_dialog)->vbox), alignment, TRUE, TRUE, 0);
		gtk_widget_show(alignment);
		
		frame = gtk_frame_new(NULL);
		gtk_container_set_border_width(GTK_CONTAINER(frame), 5);		
		gtk_container_add(GTK_CONTAINER(alignment), frame);
		gtk_widget_show(frame);

		pm_banner = make_pixmapwid(parm->sess->login_dialog, banner_xpm);
		gtk_container_add(GTK_CONTAINER(frame), pm_banner);
		gtk_widget_show(pm_banner);

		parm->notebook = gtk_notebook_new();
		gtk_notebook_set_show_border(GTK_NOTEBOOK (parm->notebook), FALSE);
		gtk_notebook_set_show_tabs(GTK_NOTEBOOK (parm->notebook), FALSE);
		gtk_box_pack_start (GTK_BOX (GTK_DIALOG (parm->sess->login_dialog)->vbox), parm->notebook, TRUE, TRUE, 0);
		gtk_widget_show(parm->notebook);

		table = gtk_table_new(2 ,4 , FALSE);
		gtk_container_set_border_width(GTK_CONTAINER(table), 10);		
		gtk_table_set_row_spacings(GTK_TABLE(table), 5);
		gtk_table_set_col_spacing(GTK_TABLE(table), 0, 20);
		gtk_notebook_append_page (GTK_NOTEBOOK (parm->notebook), table, NULL);
		gtk_widget_show(table);
		
		user_label = gtk_label_new(LOGIN_LABEL_USERNAME);
		gtk_misc_set_alignment(GTK_MISC(user_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(user_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(table), user_label, 0, 1, 0, 1);
		gtk_widget_show(user_label);
		
		pw_label = gtk_label_new(LOGIN_LABEL_PASSWORD);
		gtk_misc_set_alignment(GTK_MISC(pw_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(pw_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach(GTK_TABLE(table), GTK_WIDGET(pw_label), 0, 1, 1, 2, GTK_SHRINK|GTK_FILL, GTK_SHRINK|GTK_FILL, 0, 0);
		gtk_widget_show(pw_label);

		parm->new_user = gtk_check_button_new_with_label(LOGIN_LABEL_NEW_USER);
		gtk_table_attach_defaults(GTK_TABLE(table), parm->new_user, 0, 1, 3, 4);
		gtk_widget_show(parm->new_user);
	
		parm->retry_check = gtk_check_button_new_with_label(LOGIN_LABEL_REMEMBER);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(parm->retry_check), parm->sess->PASSWORD);
		gtk_table_attach_defaults(GTK_TABLE(table), parm->retry_check, 1, 2, 3, 4);
		gtk_widget_show(parm->retry_check);

		parm->user_entry = gtk_entry_new_with_max_length(19);
		gtk_entry_set_text(GTK_ENTRY(parm->user_entry), parm->sess->username);
		gtk_table_attach_defaults(GTK_TABLE(table), parm->user_entry, 1, 2, 0, 1);
		gtk_widget_show(parm->user_entry);
		
		parm->pw_entry = gtk_entry_new_with_max_length(19);
		gtk_entry_set_visibility(GTK_ENTRY(parm->pw_entry), FALSE);
		gtk_entry_set_text(GTK_ENTRY(parm->pw_entry), parm->sess->password);
		gtk_table_attach_defaults(GTK_TABLE(table), parm->pw_entry, 1, 2, 1, 2);
		gtk_widget_show(parm->pw_entry);		
		
		new_table = gtk_table_new(2 ,2 , FALSE);
		gtk_container_set_border_width(GTK_CONTAINER(new_table), 10);		
		gtk_table_set_row_spacings(GTK_TABLE(new_table), 5);
		gtk_table_set_col_spacing(GTK_TABLE(new_table), 0, 20);
		gtk_notebook_append_page (GTK_NOTEBOOK (parm->notebook), new_table, NULL);
		gtk_widget_show(new_table);

		pwr_label = gtk_label_new(LOGIN_LABEL_RETYPE_PASSWORD);
		gtk_misc_set_alignment(GTK_MISC(pwr_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(pwr_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(new_table), pwr_label, 0, 1, 0, 1);
		gtk_widget_show(pwr_label);
		
		email_label = gtk_label_new(LOGIN_LABEL_EMAIL);
		gtk_misc_set_alignment(GTK_MISC(email_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(email_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(new_table), email_label, 0, 1, 1, 2);
		gtk_widget_show(email_label);
		
		parm->pwr_entry = gtk_entry_new_with_max_length(19);
		gtk_entry_set_visibility(GTK_ENTRY(parm->pwr_entry), FALSE);
		gtk_table_attach_defaults(GTK_TABLE(new_table), parm->pwr_entry, 1, 2, 0, 1);
		gtk_widget_show(parm->pwr_entry);

		parm->email_entry = gtk_entry_new_with_max_length(99);
		gtk_entry_set_text(GTK_ENTRY(parm->email_entry), parm->sess->email);
		gtk_table_attach_defaults(GTK_TABLE(new_table), parm->email_entry, 1, 2, 1, 2);
		gtk_widget_show(parm->email_entry);
		
		misc_table = gtk_table_new(2 ,2 , FALSE);
		gtk_container_set_border_width(GTK_CONTAINER(misc_table), 10);		
		gtk_table_set_row_spacings(GTK_TABLE(misc_table), 5);
		gtk_table_set_col_spacing(GTK_TABLE(misc_table), 0, 20);
		gtk_notebook_append_page (GTK_NOTEBOOK (parm->notebook), misc_table, NULL);
		gtk_widget_show(misc_table);
		
		speed_label = gtk_label_new(LOGIN_LABEL_SPEED);
		gtk_misc_set_alignment(GTK_MISC(speed_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(speed_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(misc_table), speed_label, 0, 1, 0, 1);
		gtk_widget_show(speed_label);

		parm->speed_combo = gtk_combo_new();
		gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(parm->speed_combo)->entry), FALSE);
		gtk_combo_set_popdown_strings(GTK_COMBO(parm->speed_combo), linespeed);
		gtk_table_attach_defaults(GTK_TABLE(misc_table), parm->speed_combo, 1, 2, 0, 1);
		gtk_widget_show(parm->speed_combo);
		gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(parm->speed_combo)->entry), get_speed(parm->sess->speed));

		dd_label = gtk_label_new(LOGIN_LABEL_STORE);
		gtk_misc_set_alignment(GTK_MISC(dd_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(dd_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(misc_table), dd_label, 0, 1, 1, 2);
		gtk_widget_show(dd_label);
		
		parm->dd_entry = gtk_entry_new_with_max_length(99);
		gtk_entry_set_text(GTK_ENTRY(parm->dd_entry), parm->sess->directory);
		gtk_table_attach_defaults(GTK_TABLE(misc_table), parm->dd_entry, 1, 2, 1, 2);
		gtk_widget_show(parm->dd_entry);
		
		parm->sess->login_label = gtk_label_new(LOGIN_LABEL_STATUS);
		gtk_notebook_append_page (GTK_NOTEBOOK (parm->notebook), parm->sess->login_label, NULL);
		
		gtk_signal_connect(GTK_OBJECT(parm->ok_button), "clicked", GTK_SIGNAL_FUNC(ok_button_func), parm);
		gtk_signal_connect(GTK_OBJECT(parm->cancel_button), "clicked", GTK_SIGNAL_FUNC(cancel_button_func), parm);
		gtk_signal_connect(GTK_OBJECT(parm->back_button), "clicked", GTK_SIGNAL_FUNC(back_button_func), parm);
		gtk_widget_show_all(parm->sess->login_dialog);
		if(parm->sess->AUTO_CONNECT && parm->sess->PASSWORD) login_connect(parm, FALSE);
	}
	else 
	{
		gtk_message_ok(MSGBOX_CONNECTED, MSGBOX_CONNECTED_TITLE, DIALOG_WARNING);
		g_free(parm);
	}
}

void settings_ok(GtkWidget *widget, gpointer data)
{
	settings_parm *parm = (settings_parm *)data;
	
	parm->sess->speed = get_speed_nr(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(parm->speed_combo)->entry)));

	strcpy((gchar *)parm->sess->email, (gchar *)gtk_entry_get_text(GTK_ENTRY(parm->email_entry)));
	strcpy((gchar *)parm->sess->directory, (gchar *)gtk_entry_get_text(GTK_ENTRY(parm->storedir_entry)));
	strcpy((gchar *)parm->sess->exec_player, (gchar *)gtk_entry_get_text(GTK_ENTRY(parm->rundir_entry)));
	
	parm->sess->SHOW_TABS = GTK_TOGGLE_BUTTON(parm->tabs_check)->active;
	parm->sess->SHOW_BYTE = GTK_TOGGLE_BUTTON(parm->bytes_check)->active;
	parm->sess->SHOW_DHMS = GTK_TOGGLE_BUTTON(parm->dhms_check)->active;
	parm->sess->SWITCH_TRANSFER = GTK_TOGGLE_BUTTON(parm->switch_check)->active;
	parm->sess->AUTO_CONNECT = GTK_TOGGLE_BUTTON(parm->auto_check)->active;
	
	parm->sess->timeout = atoi((gchar *)gtk_entry_get_text(GTK_ENTRY(parm->timeout_entry)));

	gtk_notebook_set_show_tabs(GTK_NOTEBOOK (parm->sess->page), parm->sess->SHOW_TABS);
		
	gtk_widget_destroy(parm->dialog);
	g_free(parm);
}

void settings_cancel(GtkWidget *widget, gpointer data)
{
	settings_parm *parm = (settings_parm *)data;
	gtk_widget_destroy(parm->dialog);
	g_free(parm);
}

void settings_dialog(GtkWidget *widget, gpointer data)
{
		GtkWidget *ok_button;
		GtkWidget *cancel_button;
		GtkWidget *general_frame;
		GtkWidget *general_table;
		GtkWidget *dir_table;
		GtkWidget *dir_frame;
		GtkWidget *lf_table;
		GtkWidget *lf_frame;
		GtkWidget *email_label;
		GtkWidget *speed_label;
		GtkWidget *storedir_label;
		GtkWidget *sharedir_label;
		GtkWidget *rundir_label;
		GtkWidget *timeout_label;
		settings_parm *parm;
		gchar timeout[4];
		GList *linespeed = NULL;
		gtk_sess *sess = (gtk_sess *)data;
		
		linespeed = g_list_append(linespeed, LINE_SPEED_UNKNOWN);
		linespeed = g_list_append(linespeed, LINE_SPEED_T3);
		linespeed = g_list_append(linespeed, LINE_SPEED_T1);
		linespeed = g_list_append(linespeed, LINE_SPEED_DSL);
		linespeed = g_list_append(linespeed, LINE_SPEED_CABLE);
		linespeed = g_list_append(linespeed, LINE_SPEED_ISDN128);
		linespeed = g_list_append(linespeed, LINE_SPEED_ISDN56);
		linespeed = g_list_append(linespeed, LINE_SPEED_56MODEM);
		linespeed = g_list_append(linespeed, LINE_SPEED_33MODEM);
		linespeed = g_list_append(linespeed, LINE_SPEED_28MODEM);
		linespeed = g_list_append(linespeed, LINE_SPEED_14MODEM);

		parm = (settings_parm *)g_malloc(sizeof(settings_parm));
		parm->sess = sess;
		parm->dialog = gtk_dialog_new();
		
		gtk_window_set_position(GTK_WINDOW(parm->dialog), GTK_WIN_POS_CENTER);
		gtk_window_set_modal(GTK_WINDOW(parm->dialog), TRUE);
		gtk_window_set_title(GTK_WINDOW(parm->dialog), SETTINGS_DIALOG_TITLE);

		ok_button = gtk_button_new_with_label(BUTTON_OK);
		gtk_box_pack_start (GTK_BOX (GTK_DIALOG (parm->dialog)->action_area), ok_button, TRUE, TRUE, 0);
		gtk_widget_show(ok_button);
		
		cancel_button = gtk_button_new_with_label(BUTTON_CANCEL);
		gtk_box_pack_start (GTK_BOX (GTK_DIALOG (parm->dialog)->action_area), cancel_button, TRUE, TRUE, 0);
		gtk_widget_show(cancel_button);
		
		general_frame = gtk_frame_new(SETTINGS_FRAME_GENERAL);
		gtk_container_set_border_width(GTK_CONTAINER(general_frame), 5);		
		gtk_box_pack_start (GTK_BOX (GTK_DIALOG (parm->dialog)->vbox), general_frame, TRUE, TRUE, 0);
		gtk_widget_show(general_frame);
		
		dir_frame = gtk_frame_new(SETTINGS_FRAME_DIR);
		gtk_container_set_border_width(GTK_CONTAINER(dir_frame), 5);		
		gtk_box_pack_start (GTK_BOX (GTK_DIALOG (parm->dialog)->vbox), dir_frame, TRUE, TRUE, 0);
		gtk_widget_show(dir_frame);
		
		lf_frame = gtk_frame_new(SETTINGS_FRAME_LOOK_FEEL);
		gtk_container_set_border_width(GTK_CONTAINER(lf_frame), 5);		
		gtk_box_pack_start (GTK_BOX (GTK_DIALOG (parm->dialog)->vbox), lf_frame, TRUE, TRUE, 0);
		gtk_widget_show(lf_frame);
		
		general_table = gtk_table_new(2 ,2 , FALSE);
		gtk_container_set_border_width(GTK_CONTAINER(general_table), 10);		
		gtk_table_set_row_spacings(GTK_TABLE(general_table), 5);
		gtk_table_set_col_spacing(GTK_TABLE(general_table), 0, 20);
		gtk_container_add(GTK_CONTAINER(general_frame), general_table);
		gtk_widget_show(general_table);
		
		dir_table = gtk_table_new(2 ,3 , FALSE);
		gtk_container_set_border_width(GTK_CONTAINER(dir_table), 10);		
		gtk_table_set_row_spacings(GTK_TABLE(dir_table), 5);
		gtk_table_set_col_spacing(GTK_TABLE(dir_table), 0, 20);
		gtk_container_add(GTK_CONTAINER(dir_frame), dir_table);
		gtk_widget_show(dir_table);
		
		lf_table = gtk_table_new(2 ,6 , FALSE);
		gtk_container_set_border_width(GTK_CONTAINER(lf_table), 10);		
		gtk_container_add(GTK_CONTAINER(lf_frame), lf_table);
		gtk_widget_show(lf_table);
		
		speed_label = gtk_label_new(SETTINGS_LABEL_SPEED);
		gtk_misc_set_alignment(GTK_MISC(speed_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(speed_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(general_table), speed_label, 0, 1, 0, 1);
		gtk_widget_show(speed_label);
		
		email_label = gtk_label_new(SETTINGS_LABEL_EMAIL);
		gtk_misc_set_alignment(GTK_MISC(email_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(email_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(general_table), email_label, 0, 1, 1, 2);
		gtk_widget_show(email_label);
		
		storedir_label = gtk_label_new(SETTINGS_LABEL_STORE);
		gtk_misc_set_alignment(GTK_MISC(storedir_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(storedir_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(dir_table), storedir_label, 0, 1, 0, 1);
		gtk_widget_show(storedir_label);
		
		sharedir_label = gtk_label_new(SETTINGS_LABEL_SHARE);
		gtk_misc_set_alignment(GTK_MISC(sharedir_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(sharedir_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(dir_table), sharedir_label, 0, 1, 1, 2);
		gtk_widget_set_sensitive(GTK_WIDGET(sharedir_label), FALSE);
		gtk_widget_show(sharedir_label);
		
		rundir_label = gtk_label_new(SETTINGS_LABEL_RUN_COMMAND);
		gtk_misc_set_alignment(GTK_MISC(rundir_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(rundir_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(dir_table), rundir_label, 0, 1, 2, 3);
		gtk_widget_show(rundir_label);
		
		timeout_label = gtk_label_new(SETTINGS_LABEL_TIMEOUT);
		gtk_misc_set_alignment(GTK_MISC(timeout_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(timeout_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(lf_table), timeout_label, 0, 1, 5, 6);
		gtk_widget_show(timeout_label);
		
		parm->speed_combo = gtk_combo_new();
		gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(parm->speed_combo)->entry), FALSE);
		gtk_combo_set_popdown_strings(GTK_COMBO(parm->speed_combo), linespeed);
		gtk_table_attach_defaults(GTK_TABLE(general_table), parm->speed_combo, 1, 2, 0, 1);
		gtk_widget_show(parm->speed_combo);
		gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(parm->speed_combo)->entry), get_speed(sess->speed));

		parm->email_entry = gtk_entry_new_with_max_length(99);
		gtk_entry_set_text(GTK_ENTRY(parm->email_entry), sess->email);
		gtk_table_attach_defaults(GTK_TABLE(general_table), parm->email_entry, 1, 2, 1, 2);
		gtk_widget_show(parm->email_entry);
		
		parm->tabs_check = gtk_check_button_new_with_label(SETTINGS_LABEL_TAB);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(parm->tabs_check), sess->SHOW_TABS);
		gtk_table_attach_defaults(GTK_TABLE(lf_table), parm->tabs_check, 0, 2, 0, 1);
		gtk_widget_show(parm->tabs_check);

		parm->bytes_check = gtk_check_button_new_with_label(SETTINGS_LABEL_FILESIZE);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(parm->bytes_check), sess->SHOW_BYTE);
		gtk_table_attach_defaults(GTK_TABLE(lf_table), parm->bytes_check, 0, 2, 1, 2);
		gtk_widget_show(parm->bytes_check);
		
		parm->dhms_check = gtk_check_button_new_with_label(SETTINGS_LABEL_TIME);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(parm->dhms_check), sess->SHOW_DHMS);
		gtk_table_attach_defaults(GTK_TABLE(lf_table), parm->dhms_check, 0, 2, 2, 3);
		gtk_widget_show(parm->dhms_check);
		
		parm->switch_check = gtk_check_button_new_with_label(SETTINGS_LABEL_SWITCH);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(parm->switch_check), sess->SWITCH_TRANSFER);
		gtk_table_attach_defaults(GTK_TABLE(lf_table), parm->switch_check, 0, 2, 3, 4);
		gtk_widget_show(parm->switch_check);
		
		parm->auto_check = gtk_check_button_new_with_label(SETTINGS_LABEL_AUTO);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(parm->auto_check), sess->AUTO_CONNECT);
		gtk_table_attach_defaults(GTK_TABLE(lf_table), parm->auto_check, 0, 2, 4, 5);
		gtk_widget_show(parm->auto_check);

		parm->storedir_entry = gtk_entry_new_with_max_length(99);
		gtk_entry_set_text(GTK_ENTRY(parm->storedir_entry), sess->directory);
		gtk_table_attach_defaults(GTK_TABLE(dir_table), parm->storedir_entry, 1, 2, 0, 1);
		gtk_widget_show(parm->storedir_entry);
		
		parm->sharedir_entry = gtk_entry_new_with_max_length(99);
		gtk_widget_set_sensitive(GTK_WIDGET(parm->sharedir_entry), FALSE);
		gtk_table_attach_defaults(GTK_TABLE(dir_table), parm->sharedir_entry, 1, 2, 1, 2);
		gtk_widget_show(parm->sharedir_entry);
		
		parm->rundir_entry = gtk_entry_new_with_max_length(149);
		gtk_entry_set_text(GTK_ENTRY(parm->rundir_entry), sess->exec_player);
		gtk_table_attach_defaults(GTK_TABLE(dir_table), parm->rundir_entry, 1, 2, 2, 3);
		gtk_widget_show(parm->rundir_entry);
		
		parm->timeout_entry = gtk_entry_new_with_max_length(3);
	  	sprintf((gchar *)timeout, "%d", sess->timeout);
		gtk_entry_set_text(GTK_ENTRY(parm->timeout_entry), (gchar *)timeout);
		gtk_table_attach_defaults(GTK_TABLE(lf_table), parm->timeout_entry, 1, 2, 5, 6);
		gtk_widget_show(parm->timeout_entry);
		
		gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(settings_ok), parm);
		gtk_signal_connect(GTK_OBJECT(cancel_button), "clicked", GTK_SIGNAL_FUNC(settings_cancel), parm);

		gtk_widget_show_all(parm->dialog);
}

